# Welcome to Katana
Katana is a flexible set of components for building and hosting OWIN-based web applications on .NET Framework.

This repo is the home for the Katana host, server, and middleware source code and documentation. Official releases of Katana components (including prerelease versions) can be found on https://nuget.org.  

These products are developed by the ASP.NET team at Microsoft in collaboration with a community of open source developers.

See the list of [Packages](https://github.com/aspnet/AspNetKatana/wiki/Packages) for information about individual components.

Documentation is available in the [Wiki](https://github.com/aspnet/AspNetKatana/wiki) and overview of [OWIN and Katana](https://docs.microsoft.com/en-us/aspnet/aspnet/overview/owin-and-katana/).

## Source Code
To build and run the tests from a command prompt, run `build.cmd` (found in the root directory). Note: As part of building you may need to obtain NuGet packages from the NuGet.org public feed.

See Katana.sln in the root directory to open the solution in Visual Studio.

## Signed Nightly Builds
If you do not want to build the source, nightly builds are available via a private NuGet feed. Nightly builds are meant for developers to try out new features or bug fixes ahead of an official prerelease or final build. Nightly builds are not supported for production use.

## Nightly build feeds: 
* Dev (latest) branch: https://dotnet.myget.org/f/katana-dev/
* Release (stabilization) branch: https://dotnet.myget.org/f/katana-release/
* IdentityModel dependencies: https://www.myget.org/F/azureadwebstacknightly/

## Contribute
There are lots of ways to [contribute](https://github.com/aspnet/Home/blob/master/CONTRIBUTING.md) to the project, and we appreciate our contributors.
You can contribute by reviewing and sending feedback on code commits, suggesting and trying out new features as they are implemented, submit bugs and help us verify fixes as they are checked in, as well as submit code fixes or code contributions of your own. Note that all code submissions will be rigorously reviewed and tested by the Katana team, and only those that meet an extremely high bar for both quality and design/roadmap appropriateness will be merged into the source.

## Roadmap
For details on our planned features and future direction, please refer to our [roadmap](https://github.com/aspnet/AspNetKatana/wiki/Roadmap).
